-------------------------------------------   INSERT INTO FUNCTI  ------------------------------------
IF NOT EXISTS (SELECT Code FROM FUNCTI WHERE Code='AGC01')
BEGIN
	INSERT INTO FUNCTI VALUES(NEWID(),'AGC01','Company')
END
IF NOT EXISTS (SELECT Code FROM FUNCTI WHERE Code='AGB01')
BEGIN
	INSERT INTO FUNCTI VALUES(NEWID(),'AGB01','Branch')
END
IF NOT EXISTS (SELECT Code FROM FUNCTI WHERE Code='AGU01')
BEGIN
	INSERT INTO FUNCTI VALUES(NEWID(),'AGU01','User Account')
END
IF NOT EXISTS (SELECT Code FROM FUNCTI WHERE Code='ACR01')
BEGIN
	INSERT INTO FUNCTI VALUES(NEWID(),'ACR01','Currency')
END
-------------------------------------------   INSERT INTO OCURE  ------------------------------------
IF NOT EXISTS (SELECT Code FROM CUREER WHERE Code='KHR')
BEGIN
	INSERT INTO CUREER VALUES(NEWID(),'KHR','KH Riel','KH Riel',N'៛')
END
IF NOT EXISTS (SELECT Code FROM CUREER WHERE Code='USD')
BEGIN
	INSERT INTO CUREER VALUES(NEWID(),'USD','US Dollar','US Dollar',N'$')
END
IF NOT EXISTS (SELECT Code FROM CUREER WHERE Code='VND')
BEGIN
	INSERT INTO CUREER VALUES(NEWID(),'VND','VN Dong','VN Dong',N'₫')
END
IF NOT EXISTS (SELECT Code FROM CUREER WHERE Code='THB')
BEGIN
	INSERT INTO CUREER VALUES(NEWID(),'THB','TH Baht','TH Baht',N'฿')
END
-------------------------------------------   INSERT INTO COMP  ------------------------------------
IF NOT EXISTS (SELECT Code FROM COMPAN WHERE Code='CP001')
BEGIN
	INSERT INTO COMPAN VALUES(NEWID(),'CP001','CP001','','','',(SELECT CUR.CurrID FROM CUREER CUR WHERE Code='USD'),(SELECT CUR.CurrID FROM CUREER CUR WHERE Code='KHR'))
END
-------------------------------------------   INSERT INTO BRAN  ------------------------------------
IF NOT EXISTS (SELECT Code FROM BRANCH WHERE Code='BR001')
BEGIN
	INSERT INTO BRANCH VALUES(NEWID(),'BR001','BR001','','',(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'))
END
IF NOT EXISTS (SELECT Code FROM BRANCH WHERE Code='BR002')
BEGIN
	INSERT INTO BRANCH VALUES(NEWID(),'BR002','BR002','','',(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'))
END
IF NOT EXISTS (SELECT Code FROM BRANCH WHERE Code='BR003')
BEGIN
	INSERT INTO BRANCH VALUES(NEWID(),'BR003','BR003','','',(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'))
END
-------------------------------------------   INSERT INTO MARULE  ------------------------------------

IF NOT EXISTS (SELECT Code FROM MARULE WHERE Code='RU001')
BEGIN
	INSERT INTO MARULE VALUES(NEWID(),'RU001','SuperAdmin',1,(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'))
END
IF NOT EXISTS (SELECT Code FROM MARULE WHERE Code='RU002')
BEGIN
	INSERT INTO MARULE VALUES(NEWID(),'RU002','Admin',1,(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'))
END

-------------------------------------------   INSERT INTO RUPRIV  ------------------------------------

IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGC01' AND MR.Code='RU001')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU001'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGC01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGB01' AND MR.Code='RU001')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU001'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGB01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID
				 INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGU01' AND MR.Code='RU001')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU001'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGU01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
			INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='ACR01' AND MR.Code='RU001')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU001'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='ACR01'),1)
END
-------------- More-------------
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGC01' AND MR.Code='RU002')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU002'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGC01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGB01' AND MR.Code='RU002')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU002'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGB01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='AGU01' AND MR.Code='RU002')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU002'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='AGU01'),1)
END
IF NOT EXISTS (SELECT RP.* FROM RUPRIV RP INNER JOIN MARULE MR ON RP.RuleID = MR.RuleID 
				INNER JOIN FUNCTI FC ON RP.FunctID = FC.FunctID WHERE FC.Code='ACR01' AND MR.Code='RU002')
BEGIN
	INSERT INTO RUPRIV VALUES(NEWID(),(SELECT MR.RuleID FROM MARULE MR WHERE Code='RU002'),(SELECT FC.FunctID FROM FUNCTI FC WHERE Code='ACR01'),1)
END

-------------------------------------------   INSERT INTO DEPMENT  ------------------------------------
IF NOT EXISTS (SELECT Code FROM DEPMENT WHERE Code='DP001')
BEGIN
	INSERT INTO DEPMENT VALUES(NEWID(),'DP001','Admin',(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'),1)
END
-------------------------------------------   INSERT INTO UERACC  ------------------------------------

IF NOT EXISTS (SELECT Code FROM UERACC WHERE Code='UCC001')
BEGIN
	INSERT INTO UERACC VALUES(NEWID(),'UCC001','Admin','Admin','Admin',(SELECT RuleID FROM MARULE WHERE Code='RU001'),
	(SELECT CP.CompID FROM COMPAN CP WHERE Code='CP001'),(SELECT BranchID FROM BRANCH WHERE Code='BR001'),
	1,1,(SELECT DeparmentID FROM DEPMENT WHERE Code='DP001'))
END

------------------------------------------- CREATE ENUM TABLE ------------------------------------------


---------------------- EnumUserRules --------------------------

IF NOT EXISTS (SELECT id FROM EnumUserRules WHERE id=1)
BEGIN 
	INSERT INTO EnumUserRules (id, value) VALUES (1, 'SuperAdmin');
END
IF NOT EXISTS (SELECT id FROM EnumUserRules WHERE id=2)
BEGIN 
	INSERT INTO EnumUserRules (Id, value) VALUES (2, 'Manager');
END
IF NOT EXISTS (SELECT id FROM EnumUserRules WHERE id=3)
BEGIN 
	INSERT INTO EnumUserRules (id, value) VALUES (3, 'Admin');
END
IF NOT EXISTS (SELECT id FROM EnumUserRules WHERE id=4)
BEGIN 
	INSERT INTO EnumUserRules (id, value) VALUES (4, 'Supervisor');
END
IF NOT EXISTS (SELECT id FROM EnumUserRules WHERE id=5)
BEGIN 
	INSERT INTO EnumUserRules (id, value) VALUES (5, 'Staff');
END

---------------------- EnumUserRules --------------------------

IF NOT EXISTS (SELECT id FROM EnumUserStatus WHERE id=0)
BEGIN
	INSERT INTO EnumUserStatus (id, value) VALUES (0, 'None');
END
IF NOT EXISTS (SELECT id FROM EnumUserStatus WHERE id=1)
BEGIN
	INSERT INTO EnumUserStatus (id, value) VALUES (1, 'Active');
END
IF NOT EXISTS (SELECT id FROM EnumUserStatus WHERE id=2)
BEGIN
	INSERT INTO EnumUserStatus (id, value) VALUES (2, 'Inactive');
END
IF NOT EXISTS (SELECT id FROM EnumUserStatus WHERE id=3)
BEGIN
	INSERT INTO EnumUserStatus (id, value) VALUES (3, 'Pending');
END
IF NOT EXISTS (SELECT id FROM EnumUserStatus WHERE id=4)
BEGIN
	INSERT INTO EnumUserStatus (id, value) VALUES (4, 'Close');
END

---------------------- EnumUserRules --------------------------

IF NOT EXISTS (SELECT id FROM EnumGenders WHERE id=0)
BEGIN
	INSERT INTO EnumGenders (id, value) VALUES (0, 'None');
END

IF NOT EXISTS (SELECT id FROM EnumGenders WHERE id=1)
BEGIN
	INSERT INTO EnumGenders (id, value) VALUES (1, 'Male');
END

IF NOT EXISTS (SELECT id FROM EnumGenders WHERE id=2)
BEGIN
	INSERT INTO EnumGenders (id, value) VALUES (2, 'Female');
END

IF NOT EXISTS (SELECT id FROM EnumGenders WHERE id=3)
BEGIN
	INSERT INTO EnumGenders (id, value) VALUES (3, 'Other');
END
GO
-------------------------------------get_UserAccountsAll--------------------------------

CREATE OR ALTER FUNCTION [dbo].[get_UserAccountsAll]()
RETURNS TABLE AS 
RETURN(
SELECT 
     UA.Name AS [name]
    ,UA.Code AS [code]
    ,MR.Name AS [rule]
    ,BR.Name AS [branch]
    ,DP.Name AS [department]
    ,EG.value AS [genderValue]
    ,EG.id AS [gender]
    ,ES.value AS [statusValue]
    ,ES.id AS [status]
    FROM UERACC UA
    INNER JOIN [dbo].[BRANCH] BR ON UA.BranchID = BR.BranchID
    INNER JOIN [dbo].[DEPMENT] DP ON UA.DepartmentID = DP.DeparmentID
    INNER JOIN [dbo].[MARULE] MR ON UA.RuleID = MR.RuleID
    INNER JOIN [dbo].[EnumGenders] EG ON UA.Gender = EG.id
    INNER JOIN [dbo].[EnumUserStatus] ES ON UA.[Status] = ES.Id
)
GO






-- SELECT * FROM MARULE
-- SELECT * FROM RUPRIV
-- SELECT * FROM FUNCTI
-- SELECT * FROM COMPAN
-- SELECT * FROM FUNCTI
-- SELECT * FROM BINFOR
-- SELECT * FROM BRANCH
-- SELECT * FROM COMPAN
-- SELECT * FROM CUREER
-- SELECT * FROM CUSMER
-- SELECT * FROM MARULE
-- SELECT * FROM RUPRIV
-- SELECT * FROM VENDOR
-- SELECT * FROM UPRIVI
-- SELECT * FROM RUPRIV
-- SELECT * FROM UERACC
-- SELECT * FROM DEPMENT